{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends "_layout.html.twig" %}
{% import '_includes/macros.html.twig' as appMacros %}
{% set _section = 'flux' %}
{% set _breadcrumb = ['Flux', 'Historique des traitements'] %}

{% set is_admin = is_granted('ROLE_ADMIN') %}

{% block content %}
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <h1>
            Historique des traitements
            {#<small>Retrouver le résumé de votre activité sur DATAtourisme</small>#}
        </h1>
    </section>
    <section class="content">
    <!-- /.row -->
    <div class="row">
        <div class="col-xs-12">
            <div class="box">
                <div class="box-body no-padding">
                    {{ form_start(list.form, { 'action': app.request.pathInfo, 'method': 'GET' }) }}
                        <table class="table table-responsive table-hover m-0">
                            <thead>
                                <tr>
                                    {% set tooltipOptions = '{"side": "bottom"}' %}
                                    {{ knp_pagination_sortable(list.pagination, 'Date / Heure', 'process.createdAt', {'data-tooltip': tooltipOptions, 'title': 'Date et heure de l\'exécution du traitement'}) }}
                                    {{ knp_pagination_sortable(list.pagination, 'Flux', 'flux.name') }}
                                    {% if is_admin %}
                                        {{ knp_pagination_sortable(list.pagination, 'Structure', 'organization.name') }}
                                    {% endif %}
                                    {{ knp_pagination_sortable(list.pagination, 'Mise à jour', 'process.mode', {'data-tooltip': tooltipOptions, 'title': 'Mode de mise à jour'}) }}
                                    {{ knp_pagination_sortable(list.pagination, 'Statut', 'process.status', {'data-tooltip': tooltipOptions, 'title': 'Statut du traitement'}) }}
                                    {{ knp_pagination_sortable(list.pagination, 'Fichiers', 'file_count', {'data-tooltip': tooltipOptions, 'title': 'Nombre de fichiers XML traités, taille correspondante'}) }}
                                    {{ knp_pagination_sortable(list.pagination, 'Durée', 'process.duration', {'data-tooltip': tooltipOptions, 'title': 'Durée nécessaire pour l\'exécution du traitement'}) }}
                                    {{ knp_pagination_sortable(list.pagination, '% publication', 'published_rate', {'data-tooltip': tooltipOptions, 'title': 'Nombre de POI publiés sur le nombre de POI traités'}) }}
                                    {{ knp_pagination_sortable(list.pagination, 'Évolution', 'process.evolution', {'data-tooltip': tooltipOptions, 'title': 'Évolution du nombre de POI depuis le traitement précédent'}) }}
                                    {{ knp_pagination_sortable(list.pagination, 'Anomalies', 'anomaly_count', {'data-tooltip': tooltipOptions, 'title': 'Anomalies non bloquantes pouvant empêcher la publication de certains POI'}) }}
                                </tr>
                            </thead>
                            <tbody>
                            <tr class="table-filters">
                                <td>{{ form_widget(list.form.process_date, { 'attr': { 'class': 'input-sm', 'disabled': true } }) }}</td>
                                <td>{{ form_widget(list.form.flux, { 'attr': { 'class': 'input-sm' } }) }}</td>
                                {% if is_admin %}
                                    <td>{{ form_widget(list.form.organization, { 'attr': { 'class': 'input-sm' } }) }}</td>
                                {% endif %}
                                <td>{{ form_widget(list.form.mode, { 'attr': { 'class': 'input-sm', 'disabled': true } }) }}</td>
                                <td>{{ form_widget(list.form.status, { 'attr': { 'class': 'input-sm' } }) }}</td>
                                <td>{{ form_widget(list.form.file_count, { 'attr': { 'class': 'input-sm', 'disabled': true } }) }}</td>
                                <td>{{ form_widget(list.form.duration, { 'attr': { 'class': 'input-sm', 'disabled': true } }) }}</td>
                                <td>{{ form_widget(list.form.published_rate, { 'attr': { 'class': 'input-sm', 'disabled': true } }) }}</td>
                                <td>{{ form_widget(list.form.evolution, { 'attr': { 'class': 'input-sm', 'disabled': true } }) }}</td>
                                <td>{{ form_widget(list.form.anomaly_count, { 'attr': { 'class': 'input-sm', 'disabled': true } }) }}</td>
                            </tr>
                                {% for item in items %}
                                    {% set process = item.0 %}
                                    <tr>
                                        <td>
                                            <span data-tooltip='{"side":"right"}' title="{{ process.createdAt | localizeddate }}">
                                                {{ (process.createdAt | moment).calendar() | capitalize }}
                                            </span>
                                        </td>
                                        <td>
                                            <a href="{{ path('flux.detail', { id: process.flux.id }) }}">{{ process.flux.name }}</a>
                                        </td>
                                        {% if is_admin %}
                                            <td>
                                                <a href="{{ path('organization.administrate', { id: process.flux.organization.id }) }}">{{ process.flux.organization.name }}</a>
                                            </td>
                                        {% endif %}
                                        <td nowrap>
                                            {{ appMacros.process_mode_frame(process.modeInfos.mode, process.modeInfos.label, process.modeInfos.description) }}
                                        </td>
                                        <td>
                                            {{ appMacros.process_status_frame(process.StatusInfos.status, process.statusInfos.label, process.statusInfos.description) }}
                                        </td>
                                        <td>
                                            {% if item.file_count > 0 %}
                                                <strong>{{ item.file_count | number_format }}</strong> fichier{{ item.file_count > 1 ? 's' }} - {{ appMacros.bytesToSize(item.total_size) }}
                                            {% else %}-{% endif %}
                                        </td>
                                        <td>{{ process.duration < 60 ? process.duration ~ ' s' : ( process.duration / 60 ) | round ~ ' min' }}</td>
                                        {% if process.status != constant('STATUS_ERROR', process) and process.status != constant('STATUS_RUNNING', process) %}
                                            <td>
                                                {{ appMacros.progress_bar(process) }}
                                            </td>
                                            <td class="text-right">
                                                {{ appMacros.percent_color(process.evolution) }}
                                            </td>
                                            <td class="text-right">
                                                {% if process.statsProduceRDF and process.statsProduceRDF.anomalies.total > 0 %}
                                                    <span class="text-orange _tooltip" data-tooltip="{{ tooltipOptions }}" title="Erreurs de validation détectées sur les POI">
                                                        <span class="fa fa-warning"></span>
                                                    </span>
                                                    {{ process.statsProduceRDF.anomalies.total | number_format }}
                                                {% endif %}
                                            </td>
                                        {% else %}
                                            <td class="text-right">-</td>
                                            <td class="text-right">-</td>
                                            <td class="text-right">-</td>
                                        {% endif %}
                                    </tr>
                                {% endfor %}
                            </tbody>
                        </table>
                    {{ form_end(list.form) }}
                </div>

                {% if items | length == 0 %}
                    <div class="blankslate blankslate-spacious">
                        <h3>Aucun traitement ne correspond à votre recherche.</h3>
                    </div>
                {% endif %}

                <!-- /.box-body -->
                {% if list.totalItemCount > page_size %}
                    <div class="box-footer">
                        {{ appMacros.display_list_position(list, page_size) }}
                        {{ knp_pagination_render(list.pagination, null, [], {class: "pagination-sm no-margin pull-right"}) }}
                    </div>
                {% endif %}
            </div>
        </div>
    </div>
{% endblock %}